/*
 * IRC - Internet Relay Chat, include/h.h
 * Copyright (C) 1996 - 1997 Carlo Wood
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef H_H
#define H_H

/*
 * Only put structures here whose pointer is being used as parameter
 * in function prototypes in (a large number of) other header files,
 * or as pointer in structures defined in struct.h.
 */

struct Client;
struct Server;
struct User;
struct Channel;
struct SMode;
struct ConfItem;
struct Message;
struct Gline;
struct ListingArgs;

typedef struct Client aClient;
typedef struct Server aServer;
typedef struct User anUser;
typedef struct Channel aChannel;
typedef struct SMode Mode;
typedef struct ConfItem aConfItem;
typedef struct Message aMessage;
typedef struct Gline aGline;
typedef struct ListingArgs aListingArgs;
typedef unsigned int snomask_t;

#include "s_debug.h"

#endif /* H_H */
